Index: /palm/trunk/SOURCE/data_output_module.f90
===================================================================
--- /palm/trunk/SOURCE/data_output_module.f90	(revision 4140)
+++ /palm/trunk/SOURCE/data_output_module.f90	(revision 4141)
@@ -2219,5 +2977,130 @@
    ENDIF
 
-END SUBROUTINE dom_init_file_header
+END SUBROUTINE init_file_header
+
+!--------------------------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Initialize dimension in file.
+!--------------------------------------------------------------------------------------------------!
+SUBROUTINE init_file_dimension( file_format, file_id, file_name,              &
+              dimension_id, dimension_name, dimension_type, dimension_length, &
+              variable_id, return_value )
+
+   CHARACTER(LEN=*), INTENT(IN) ::  dimension_name  !< name of dimension
+   CHARACTER(LEN=*), INTENT(IN) ::  dimension_type  !< data type of dimension
+   CHARACTER(LEN=*), INTENT(IN) ::  file_format     !< file format chosen for file
+   CHARACTER(LEN=*), INTENT(IN) ::  file_name       !< name of file
+
+   CHARACTER(LEN=*), PARAMETER ::  routine_name = 'init_file_dimension'  !< file format chosen for file
+
+   INTEGER, INTENT(OUT) ::  dimension_id         !< dimension ID
+   INTEGER, INTENT(IN)  ::  dimension_length     !< length of dimension
+   INTEGER, INTENT(IN)  ::  file_id              !< file ID
+   INTEGER              ::  output_return_value  !< return value of a called output routine
+   INTEGER, INTENT(OUT) ::  return_value         !< return value
+   INTEGER, INTENT(OUT) ::  variable_id          !< associated variable ID
+
+
+   return_value = 0
+   output_return_value = 0
+
+   temp_string = '(file "' // TRIM( file_name ) // &
+                 '", dimension "' // TRIM( dimension_name ) // '")'
+
+   SELECT CASE ( TRIM( file_format ) )
+
+      CASE ( 'binary' )
+         CALL binary_init_dimension( 'binary', file_id, dimension_id, variable_id, &
+                 dimension_name, dimension_type, dimension_length,                 &
+                 return_value=output_return_value )
+
+      CASE ( 'netcdf4-serial' )
+         CALL netcdf4_init_dimension( 'serial', file_id, dimension_id, variable_id, &
+                 dimension_name, dimension_type, dimension_length,                  &
+                 return_value=output_return_value )
+
+      CASE ( 'netcdf4-parallel' )
+         CALL netcdf4_init_dimension( 'parallel', file_id, dimension_id, variable_id, &
+                 dimension_name, dimension_type, dimension_length,                    &
+                 return_value=output_return_value )
+
+      CASE DEFAULT
+         return_value = 1
+         CALL internal_message( 'error', routine_name //                    &
+                                ': file format "' // TRIM( file_format ) // &
+                                '" not supported ' // TRIM( temp_string ) )
+
+   END SELECT
+
+   IF ( output_return_value /= 0 )  THEN
+      return_value = output_return_value
+      CALL internal_message( 'error', routine_name // &
+                             ': error while defining dimension ' // TRIM( temp_string ) )
+   ENDIF
+
+END SUBROUTINE init_file_dimension
+
+!--------------------------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Initialize variable.
+!--------------------------------------------------------------------------------------------------!
+SUBROUTINE init_file_variable( file_format, file_id, file_name,        &
+                               variable_id, variable_name, variable_type, dimension_ids, &
+                               is_global, return_value )
+
+   CHARACTER(LEN=*), INTENT(IN) ::  file_format    !< file format chosen for file
+   CHARACTER(LEN=*), INTENT(IN) ::  file_name      !< file name
+   CHARACTER(LEN=*), INTENT(IN) ::  variable_name  !< name of variable
+   CHARACTER(LEN=*), INTENT(IN) ::  variable_type  !< data type of variable
+
+   CHARACTER(LEN=*), PARAMETER ::  routine_name = 'init_file_variable'  !< file format chosen for file
+
+   INTEGER, INTENT(IN)  ::  file_id              !< file ID
+   INTEGER              ::  output_return_value  !< return value of a called output routine
+   INTEGER, INTENT(OUT) ::  return_value         !< return value
+   INTEGER, INTENT(OUT) ::  variable_id          !< variable ID
+
+   INTEGER, DIMENSION(:), INTENT(IN) ::  dimension_ids  !< list of dimension IDs used by variable
+
+   LOGICAL, INTENT(IN)  ::  is_global  !< true if variable is global
+
+
+   return_value = 0
+   output_return_value = 0
+
+   temp_string = '(file "' // TRIM( file_name ) // &
+                 '", variable "' // TRIM( variable_name ) // '")'
+
+   SELECT CASE ( TRIM( file_format ) )
+
+      CASE ( 'binary' )
+         CALL binary_init_variable( 'binary', file_id, variable_id, variable_name, &
+                 variable_type, dimension_ids, is_global, return_value=output_return_value )
+
+      CASE ( 'netcdf4-serial' )
+         CALL netcdf4_init_variable( 'serial', file_id, variable_id, variable_name, &
+                 variable_type, dimension_ids, is_global, return_value=output_return_value )
+
+      CASE ( 'netcdf4-parallel' )
+         CALL netcdf4_init_variable( 'parallel', file_id, variable_id, variable_name, &
+                 variable_type, dimension_ids, is_global, return_value=output_return_value )
+
+      CASE DEFAULT
+         return_value = 1
+         CALL internal_message( 'error', routine_name //                    &
+                                ': file format "' // TRIM( file_format ) // &
+                                '" not supported ' // TRIM( temp_string ) )
+
+   END SELECT
+
+   IF ( output_return_value /= 0 )  THEN
+      return_value = output_return_value
+      CALL internal_message( 'error', routine_name // &
+                             ': error while defining variable ' // TRIM( temp_string ) )
+   ENDIF
+
+END SUBROUTINE init_file_variable
 
 !--------------------------------------------------------------------------------------------------!
@@ -2226,16 +3109,17 @@
 !> Write attribute to file.
 !--------------------------------------------------------------------------------------------------!
-FUNCTION write_attribute( file_format, file_id, file_name, var_id, var_name, attribute ) RESULT( return_value )
-
-   CHARACTER(LEN=*), INTENT(IN) ::  file_format  !< file format chosen for file
-   CHARACTER(LEN=*), INTENT(IN) ::  file_name    !< file name
-   CHARACTER(LEN=*), INTENT(IN), OPTIONAL ::  var_name     !< variable name
+FUNCTION write_attribute( file_format, file_id, file_name,        &
+                          variable_id, variable_name, attribute ) RESULT( return_value )
+
+   CHARACTER(LEN=*), INTENT(IN) ::  file_format    !< file format chosen for file
+   CHARACTER(LEN=*), INTENT(IN) ::  file_name      !< file name
+   CHARACTER(LEN=*), INTENT(IN) ::  variable_name  !< variable name
 
    CHARACTER(LEN=*), PARAMETER ::  routine_name = 'write_attribute'  !< file format chosen for file
 
-   INTEGER(iwp), INTENT(IN) ::  file_id              !< file ID
-   INTEGER(iwp)             ::  return_value         !< return value
-   INTEGER(iwp)             ::  output_return_value  !< return value of a called output routine
-   INTEGER(iwp), INTENT(IN) ::  var_id               !< variable ID
+   INTEGER, INTENT(IN) ::  file_id              !< file ID
+   INTEGER             ::  return_value         !< return value
+   INTEGER             ::  output_return_value  !< return value of a called output routine
+   INTEGER, INTENT(IN) ::  variable_id          !< variable ID
 
    TYPE(attribute_type), INTENT(IN) ::  attribute  !< attribute to be written
@@ -2246,12 +3130,7 @@
 
    !-- Prepare for possible error message
-   IF ( PRESENT( var_name ) )  THEN
-      temp_string = '(file "' // TRIM( file_name ) //      &
-                    '", variable "' // TRIM( var_name ) // &
-                    '", attribute "' // TRIM( attribute%name ) // '")'
-   ELSE
-      temp_string = '(file "' // TRIM( file_name ) // &
-                    '", attribute "' // TRIM( attribute%name ) // '")'
-   ENDIF
+   temp_string = '(file "' // TRIM( file_name ) //           &
+                 '", variable "' // TRIM( variable_name ) // &
+                 '", attribute "' // TRIM( attribute%name ) // '")'
 
    !-- Write attribute to file
@@ -2263,31 +3142,31 @@
 
             CASE( 'char' )
-               CALL binary_write_attribute( file_id=file_id, var_id=var_id,          &
-                       att_name=attribute%name, att_value_char=attribute%value_char, &
+               CALL binary_write_attribute( file_id=file_id, variable_id=variable_id,  &
+                       attribute_name=attribute%name, value_char=attribute%value_char, &
                        return_value=output_return_value )
 
             CASE( 'int8' )
-               CALL binary_write_attribute( file_id=file_id, var_id=var_id,          &
-                       att_name=attribute%name, att_value_int8=attribute%value_int8, &
+               CALL binary_write_attribute( file_id=file_id, variable_id=variable_id,  &
+                       attribute_name=attribute%name, value_int8=attribute%value_int8, &
                        return_value=output_return_value )
 
             CASE( 'int16' )
-               CALL binary_write_attribute( file_id=file_id, var_id=var_id,            &
-                       att_name=attribute%name, att_value_int16=attribute%value_int16, &
+               CALL binary_write_attribute( file_id=file_id, variable_id=variable_id,    &
+                       attribute_name=attribute%name, value_int16=attribute%value_int16, &
                        return_value=output_return_value )
 
             CASE( 'int32' )
-               CALL binary_write_attribute( file_id=file_id, var_id=var_id,            &
-                       att_name=attribute%name, att_value_int32=attribute%value_int32, &
+               CALL binary_write_attribute( file_id=file_id, variable_id=variable_id,    &
+                       attribute_name=attribute%name, value_int32=attribute%value_int32, &
                        return_value=output_return_value )
 
             CASE( 'real32' )
-               CALL binary_write_attribute( file_id=file_id, var_id=var_id,              &
-                       att_name=attribute%name, att_value_real32=attribute%value_real32, &
+               CALL binary_write_attribute( file_id=file_id, variable_id=variable_id,      &
+                       attribute_name=attribute%name, value_real32=attribute%value_real32, &
                        return_value=output_return_value )
 
             CASE( 'real64' )
-               CALL binary_write_attribute( file_id=file_id, var_id=var_id,              &
-                       att_name=attribute%name, att_value_real64=attribute%value_real64, &
+               CALL binary_write_attribute( file_id=file_id, variable_id=variable_id,      &
+                       attribute_name=attribute%name, value_real64=attribute%value_real64, &
                        return_value=output_return_value )
 
@@ -2307,31 +3186,31 @@
 
             CASE( 'char' )
-               CALL netcdf4_write_attribute( file_id=file_id, var_id=var_id,  &
-                       att_name=attribute%name, att_value_char=attribute%value_char, &
+               CALL netcdf4_write_attribute( file_id=file_id, variable_id=variable_id, &
+                       attribute_name=attribute%name, value_char=attribute%value_char, &
                        return_value=output_return_value )
 
             CASE( 'int8' )
-               CALL netcdf4_write_attribute( file_id=file_id, var_id=var_id,  &
-                       att_name=attribute%name, att_value_int8=attribute%value_int8, &
+               CALL netcdf4_write_attribute( file_id=file_id, variable_id=variable_id, &
+                       attribute_name=attribute%name, value_int8=attribute%value_int8, &
                        return_value=output_return_value )
 
             CASE( 'int16' )
-               CALL netcdf4_write_attribute( file_id=file_id, var_id=var_id,    &
-                       att_name=attribute%name, att_value_int16=attribute%value_int16, &
+               CALL netcdf4_write_attribute( file_id=file_id, variable_id=variable_id,   &
+                       attribute_name=attribute%name, value_int16=attribute%value_int16, &
                        return_value=output_return_value )
 
             CASE( 'int32' )
-               CALL netcdf4_write_attribute( file_id=file_id, var_id=var_id,    &
-                       att_name=attribute%name, att_value_int32=attribute%value_int32, &
+               CALL netcdf4_write_attribute( file_id=file_id, variable_id=variable_id,   &
+                       attribute_name=attribute%name, value_int32=attribute%value_int32, &
                        return_value=output_return_value )
 
             CASE( 'real32' )
-               CALL netcdf4_write_attribute( file_id=file_id, var_id=var_id,      &
-                       att_name=attribute%name, att_value_real32=attribute%value_real32, &
+               CALL netcdf4_write_attribute( file_id=file_id, variable_id=variable_id,     &
+                       attribute_name=attribute%name, value_real32=attribute%value_real32, &
                        return_value=output_return_value )
 
             CASE( 'real64' )
-               CALL netcdf4_write_attribute( file_id=file_id, var_id=var_id,      &
-                       att_name=attribute%name, att_value_real64=attribute%value_real64, &
+               CALL netcdf4_write_attribute( file_id=file_id, variable_id=variable_id,     &
+                       attribute_name=attribute%name, value_real64=attribute%value_real64, &
                        return_value=output_return_value )
 
@@ -2348,68 +3227,7 @@
       CASE DEFAULT
          return_value = 1
-         CALL internal_message( 'error',        &
-                                routine_name // &
+         CALL internal_message( 'error', routine_name //                                &
                                 ': unsupported file format "' // TRIM( file_format ) // &
                                 '" ' // TRIM( temp_string ) )
-
-   END SELECT
-
-   IF ( output_return_value /= 0 )  THEN
-      return_value = output_return_value
-      CALL internal_message( 'error',        &
-                             routine_name // &
-                             ': error while writing attribute ' // TRIM( temp_string ) )
-   ENDIF
-
-END FUNCTION write_attribute
-
-!--------------------------------------------------------------------------------------------------!
-! Description:
-! ------------
-!> Initialize dimension in file.
-!--------------------------------------------------------------------------------------------------!
-SUBROUTINE init_file_dimension( file_format, file_id, file_name, dim_id, var_id, &
-                                dim_name, dim_type, dim_length, return_value )
-
-   CHARACTER(LEN=*), INTENT(IN) ::  dim_name     !< name of dimension
-   CHARACTER(LEN=*), INTENT(IN) ::  dim_type     !< data type of dimension
-   CHARACTER(LEN=*), INTENT(IN) ::  file_format  !< file format chosen for file
-   CHARACTER(LEN=*), INTENT(IN) ::  file_name    !< name of file
-
-   CHARACTER(LEN=*), PARAMETER ::  routine_name = 'init_file_dimension'  !< file format chosen for file
-
-   INTEGER(iwp), INTENT(OUT) ::  dim_id               !< dimension ID
-   INTEGER(iwp), INTENT(IN)  ::  dim_length           !< length of dimension
-   INTEGER(iwp), INTENT(IN)  ::  file_id              !< file ID
-   INTEGER(iwp)              ::  output_return_value  !< return value of a called output routine
-   INTEGER(iwp), INTENT(OUT) ::  return_value         !< return value
-   INTEGER(iwp), INTENT(OUT) ::  var_id               !< associated variable ID
-
-
-   return_value = 0
-   output_return_value = 0
-
-   temp_string = '(file "' // TRIM( file_name ) // &
-                 '", dimension "' // TRIM( dim_name ) // '")'
-
-   SELECT CASE ( TRIM( file_format ) )
-
-      CASE ( 'binary' )
-         CALL binary_init_dimension( 'binary', file_id, dim_id, var_id, &
-                 dim_name, dim_type, dim_length, return_value=output_return_value )
-
-      CASE ( 'netcdf4-serial' )
-         CALL netcdf4_init_dimension( 'serial', file_id, dim_id, var_id, &
-                 dim_name, dim_type, dim_length, return_value=output_return_value )
-
-      CASE ( 'netcdf4-parallel' )
-         CALL netcdf4_init_dimension( 'parallel', file_id, dim_id, var_id, &
-                 dim_name, dim_type, dim_length, return_value=output_return_value )
-
-      CASE DEFAULT
-         return_value = 1
-         CALL internal_message( 'error', routine_name //                    &
-                                ': file format "' // TRIM( file_format ) // &
-                                '" not supported ' // TRIM( temp_string ) )
 
    END SELECT
@@ -2418,8 +3236,8 @@
       return_value = output_return_value
       CALL internal_message( 'error', routine_name // &
-                             ': error while defining dimension ' // TRIM( temp_string ) )
+                             ': error while writing attribute ' // TRIM( temp_string ) )
    ENDIF
 
-END SUBROUTINE init_file_dimension
+END FUNCTION write_attribute
 
 !--------------------------------------------------------------------------------------------------!
@@ -2428,14 +3246,16 @@
 !> Get dimension IDs and save them to variables.
 !--------------------------------------------------------------------------------------------------!
-SUBROUTINE collect_dimesion_ids_for_variables( variables, dimensions, return_value )
+SUBROUTINE collect_dimesion_ids_for_variables( file_name, variables, dimensions, return_value )
+
+   CHARACTER(LEN=*), INTENT(IN) ::  file_name !< name of file
 
    CHARACTER(LEN=*), PARAMETER ::  routine_name = 'collect_dimesion_ids_for_variables'  !< file format chosen for file
 
-   INTEGER(iwp) ::  d             !< loop index
-   INTEGER(iwp) ::  i             !< loop index
-   INTEGER(iwp) ::  j             !< loop index
-   INTEGER(iwp) ::  ndim          !< number of dimensions
-   INTEGER(iwp) ::  nvar          !< number of variables
-   INTEGER(iwp) ::  return_value  !< return value
+   INTEGER              ::  d             !< loop index
+   INTEGER              ::  i             !< loop index
+   INTEGER              ::  j             !< loop index
+   INTEGER              ::  ndims         !< number of dimensions
+   INTEGER              ::  nvars         !< number of variables
+   INTEGER, INTENT(OUT) ::  return_value  !< return value
 
    LOGICAL ::  found  !< true if dimension required by variable was found in dimension list
@@ -2447,11 +3267,11 @@
 
    return_value  = 0
-   ndim = SIZE( dimensions )
-   nvar = SIZE( variables )
-
-   DO  i = 1, nvar
+   ndims = SIZE( dimensions )
+   nvars = SIZE( variables )
+
+   DO  i = 1, nvars
       DO  j = 1, SIZE( variables(i)%dimension_names )
          found = .FALSE.
-         DO  d = 1, ndim
+         DO  d = 1, ndims
             IF ( variables(i)%dimension_names(j) == dimensions(d)%name )  THEN
                variables(i)%dimension_ids(j) = dimensions(d)%id
@@ -2462,8 +3282,8 @@
          IF ( .NOT. found )  THEN
             return_value = 1
-            CALL internal_message( 'error',                                                 &
-                    routine_name // ': variable "' // TRIM( variables(i)%name ) //          &
-                    '": required dimension "' // TRIM( variables(i)%dimension_names(j) ) // &
-                    '" is undefined' )
+            CALL internal_message( 'error', routine_name //                                &
+                    ': required dimension "' // TRIM( variables(i)%dimension_names(j) ) // &
+                    '" is undefined (variable "' // TRIM( variables(i)%name ) //           &
+                    '", file "' // TRIM( file_name ) // '")!' )
             EXIT
          ENDIF
@@ -2477,25 +3297,18 @@
 ! Description:
 ! ------------
-!> Initialize variable.
-!--------------------------------------------------------------------------------------------------!
-SUBROUTINE init_file_variable( file_format, file_id, file_name,        &
-                               var_id, var_name, var_type, var_dim_id, &
-                               is_global, return_value )
-
-   CHARACTER(LEN=*), INTENT(IN) ::  file_format  !< file format chosen for file
+!> Leave file definition/initialization.
+!>
+!> @todo Do we need an MPI barrier at the end?
+!--------------------------------------------------------------------------------------------------!
+SUBROUTINE stop_file_header_definition( file_format, file_id, file_name, return_value )
+
+   CHARACTER(LEN=*), INTENT(IN) ::  file_format  !< file format
    CHARACTER(LEN=*), INTENT(IN) ::  file_name    !< file name
-   CHARACTER(LEN=*), INTENT(IN) ::  var_name     !< name of variable
-   CHARACTER(LEN=*), INTENT(IN) ::  var_type     !< data type of variable
-
-   CHARACTER(LEN=*), PARAMETER ::  routine_name = 'init_file_variable'  !< file format chosen for file
-
-   INTEGER(iwp), INTENT(IN)  ::  file_id              !< file ID
-   INTEGER(iwp)              ::  output_return_value  !< return value of a called output routine
-   INTEGER(iwp), INTENT(OUT) ::  return_value         !< return value
-   INTEGER(iwp), INTENT(OUT) ::  var_id               !< variable ID
-
-   INTEGER(iwp), DIMENSION(:), INTENT(IN) ::  var_dim_id  !< list of dimension IDs used by variable
-
-   LOGICAL, INTENT(IN)  ::  is_global  !< true if variable is global
+
+   CHARACTER(LEN=*), PARAMETER ::  routine_name = 'stop_file_header_definition'  !< name of routine
+
+   INTEGER, INTENT(IN)  ::  file_id              !< file id
+   INTEGER              ::  output_return_value  !< return value of a called output routine
+   INTEGER, INTENT(OUT) ::  return_value         !< return value
 
 
@@ -2503,20 +3316,13 @@
    output_return_value = 0
 
-   temp_string = '(file "' // TRIM( file_name ) // &
-                 '", variable "' // TRIM( var_name ) // '")'
+   temp_string = '(file "' // TRIM( file_name ) // '")'
 
    SELECT CASE ( TRIM( file_format ) )
 
       CASE ( 'binary' )
-         CALL binary_init_variable( 'binary', file_id, var_id, var_name, var_type, &
-                                    var_dim_id, is_global, return_value=output_return_value )
-
-      CASE ( 'netcdf4-serial' )
-         CALL netcdf4_init_variable( 'serial', file_id, var_id, var_name, var_type, &
-                                     var_dim_id, is_global, return_value=output_return_value )
-
-      CASE ( 'netcdf4-parallel' )
-         CALL netcdf4_init_variable( 'parallel', file_id, var_id, var_name, var_type, &
-                                     var_dim_id, is_global, return_value=output_return_value )
+         CALL binary_stop_file_header_definition( file_id, output_return_value )
+
+      CASE ( 'netcdf4-parallel', 'netcdf4-serial' )
+         CALL netcdf4_stop_file_header_definition( file_id, output_return_value )
 
       CASE DEFAULT
@@ -2530,53 +3336,5 @@
    IF ( output_return_value /= 0 )  THEN
       return_value = output_return_value
-      CALL internal_message( 'error', routine_name // &
-                             ': error while defining variable ' // TRIM( temp_string ) )
-   ENDIF
-
-END SUBROUTINE init_file_variable
-
-!--------------------------------------------------------------------------------------------------!
-! Description:
-! ------------
-!> Finalize file definition/initialization.
-!>
-!> @todo Do we need an MPI barrier at the end?
-!--------------------------------------------------------------------------------------------------!
-SUBROUTINE dom_init_end( file_format, file_id, file_name, return_value )
-
-   CHARACTER(LEN=*), INTENT(IN) ::  file_format  !< file format
-   CHARACTER(LEN=*), INTENT(IN) ::  file_name    !< file name
-
-   CHARACTER(LEN=*), PARAMETER ::  routine_name = 'dom_init_end'  !< name of routine
-
-   INTEGER(iwp), INTENT(IN)  ::  file_id              !< file id
-   INTEGER(iwp)              ::  output_return_value  !< return value of a called output routine
-   INTEGER(iwp), INTENT(OUT) ::  return_value         !< return value
-
-
-   return_value = 0
-   output_return_value = 0
-
-   temp_string = '(file "' // TRIM( file_name ) // '")'
-
-   SELECT CASE ( TRIM( file_format ) )
-
-      CASE ( 'binary' )
-         CALL binary_init_end( file_id, output_return_value )
-
-      CASE ( 'netcdf4-parallel', 'netcdf4-serial' )
-         CALL netcdf4_init_end( file_id, output_return_value )
-
-      CASE DEFAULT
-         return_value = 1
-         CALL internal_message( 'error', routine_name //                    &
-                                ': file format "' // TRIM( file_format ) // &
-                                '" not supported ' // TRIM( temp_string ) )
-
-   END SELECT
-
-   IF ( output_return_value /= 0 )  THEN
-      return_value = output_return_value
-      CALL internal_message( 'error', routine_name // &
+      CALL internal_message( 'error', routine_name //                          &
                              ': error while leaving file-definition state ' // &
                              TRIM( temp_string ) )
